% kernel_gpml_map:
%
% Unfortunately, the GPML library has a different representation for
% kernel function hyperparameters than the one we believe is most natural 
% to us. This function defines a map between the two representations.
% If 'direction' == 1, it maps from ours to GPML. Otherwise, it maps in the
% opposite direction

function new_values = kernel_gpml_map(covfunc, values, direction)

kernel_testvalid(covfunc);

if direction == 1
   new_values = log(sqrt(values));
else
   new_values = exp(values) .^ 2;
end
