% get_node_order:
%
% Returns an ordering for the nodes in 'graph' such that no node can
% precede any of its descendants.

function order = get_node_order(graph)

p = length(graph);
parents = cell(p, 1);
for v = 1:p
    parents{p} = find(graph(p, :) == 1);
end

order = zeros(p, 1);
sorted = zeros(p, 1);
next_n = 1;

while sum(sorted) ~= p
    for i = 1:p
        if sorted(i)
           continue
        end
        if sum(sorted(parents{i})) ~= length(parents{i})
           continue
        end
        order(next_n) = i;
        sorted(i) = 1;
        next_n = next_n + 1;        
    end
end
