% get_x:
%
% Reads a logfile of latent variables generated by mcmc_gpsem_fspgp,
% then report all samples

function x = get_x(file_name, num_latents, sample_size, mcmc_size)

%error('broken!');
%
%file_id    = fopen(file_name, 'r');
%x          = zeros(mcmc_size, sample_size, num_latents);
%data_line  = textscan(file_id, '%f', num_latents);
%mcmc_count = 1;
%
%while ~feof(file_id)
%    % Read the next MCMC sample
%    disp(sprintf('mcmc #%d', mcmc_count));
%    for d = 1:sample_size        
%        x(mcmc_count, d, :) = data_line{1};
%        data_line = textscan(file_id, '%f', num_latents);
%    end
%    mcmc_count = mcmc_count + 1;
%end
%
%fclose(file_id);

file_id    = fopen(file_name, 'r');
x          = zeros(mcmc_size, sample_size, num_latents);
data_line  = textscan(file_id, '%f', num_latents);
mcmc_count = 1;

while ~feof(file_id)
    % Read the next MCMC sample
    disp(sprintf('mcmc #%d', mcmc_count));
    buffer_pos = 1;
    for d = 1:sample_size 
        buffer(buffer_pos:(buffer_pos + num_latents - 1)) = data_line{1};
        buffer_pos = buffer_pos + num_latents;
        data_line = textscan(file_id, '%f', num_latents);
    end
    x(mcmc_count, :, :) = reshape(buffer, sample_size, num_latents); % Notice peculiar format
    mcmc_count = mcmc_count + 1;
end

fclose(file_id);

