% normalize_training:
%
% Normalize a whole dataset using the mean and variance of a subset
% ('train_points').

function new_data = normalize_training(data, train_points, mars_matrix)

%sds = 1 ./ sqrt(diag(cov(data(train_points, :))));
%mn = mean(data(train_points, :));

num_vars = size(data, 2);
sds      = zeros(num_vars, 1);
mn       = zeros(1, num_vars);
for v = 1:num_vars
    visible = intersect(find(mars_matrix(:, v) == 0), train_points);
    sds(v)   = 1 / sqrt(var(data(visible, v)));
    mn(v) = mean(data(visible, v));
end

new_data = data - repmat(mn, size(data, 1), 1);
new_data = new_data .* repmat(sds', size(data, 1), 1); 
