%%%%%%
% r_creation:
%
% Saves sampled latents as text files, so we can load them in R
%
% One file for each latent variable.
%
% Input: a matrix obtained by loading a MCMC trace with 'get_x'.

function r_creation(file_name, sample_latents)

[mcmc_size sample_size num_latents] = size(sample_latents);

for i = 1:num_latents
    r_name = strcat(file_name, '.', int2str(i), '.dat');
    vv = sample_latents(:, :, i);
    save(r_name, 'vv', '-ascii');
end
